﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication29
{
    public partial class Form1 : Form
    {

        Bitmap bmp;
        Graphics g;

        public Form1()
        {
            InitializeComponent();
            bmp = new Bitmap(Width, Height);
            
            pictureBox1.Image = bmp;

            g = Graphics.FromImage(bmp);
        }

        private void button1_Click_(object sender, EventArgs e)
        {
            Pen pero = new Pen(Color.Red, 5);
            pero.StartCap = System.Drawing.Drawing2D.LineCap.Round;
            pero.EndCap = System.Drawing.Drawing2D.LineCap.Round;

            int minx = 0;
            int miny = 0;
            for (int fi = 0; fi < 3*360; fi++)
            {
                int x = 50+2*fi;
                    x = 50 + (int)(200 + 100 * Math.Sin(5*fi / 2/360.00 * 2 * Math.PI));
                int y = 100 + (int)(100 + 100 * Math.Cos(4*fi / 2/360.00 * 2 * Math.PI));

                //pero.Width = fi/2;

                //if (fi > 0)
                //    g.DrawLine(pero, minx, miny, x, y);
                g.FillRectangle(Brushes.Yellow, x, y, 50, 30);
                g.DrawRectangle(Pens.Black, x, y, 50, 30);
                minx = x; miny = y;
                pictureBox1.Refresh();
            }

      }
        private void button1_Click__(object sender, EventArgs e)
        {
            int sx = pictureBox1.Width / 16;
            int sy = pictureBox1.Height / 16;

            for (int i = 0; i < 16; i++)
            {
                for (int j = 0; j < 16; j++)
                {
                    int x = i * sx;
                    int y = j * sy;

                    Color barva = Color.FromArgb(0, 17 * i, 17 * j);
                    Brush stetec = new SolidBrush(barva);

                    g.FillRectangle(stetec, x, y, sx - 2, sy - 2);
                    g.DrawRectangle(Pens.Black, x, y, sx - 2, sy - 2);

                }
            }
            pictureBox1.Refresh();

        }
        private void button1_Click___(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap)pictureBox2.Image;
            int sirka = pictureBox2.Width;
            int vyska = pictureBox2.Height;

            int[] zbytky;
            int[] pristiZbytky = new int[vyska];

            for (int x = 0; x < sirka; x++)
            {
                zbytky = pristiZbytky;
                pristiZbytky = new int[vyska];

                for (int y = 0; y < vyska; y++)
                {
                    int xx = x;
                    int yy = y;
                    //xx += (x + (int)(50 * Math.Sin(y / 30.00)) + sirka) % sirka;
                    //yy += (y + (int)(50 * Math.Sin(x / 30.00)) + vyska) % vyska;

                    Color c = vzor.GetPixel(xx, yy);
                    int r = c.R;
                    int g = c.G;
                    int b = c.B;

                    int s = (int)(r*0.2989 + g*0.5866 + b*(1-0.2989-0.5866));

                    //s = (int)Math.Sqrt(s) * 17;
                    //s = (int)Math.Sqrt(s) * 17;
                    //s = (int)Math.Sqrt(s) * 17;

                    //s = s * s / 255;

                    s += zbytky[y];

                    if (s > trackBar1.Value)
                    {
                        c = Color.White;
                        s -= trackBar1.Value;
                    }
                    else
                        c = Color.Black;

                    // rozdelein zbyleho svetla:
                    if (y < vyska - 1)
                        zbytky[y + 1] += s / 4;
                    if (y > 0)
                        pristiZbytky[y - 1] += s / 4;
                    pristiZbytky[y] += s / 4;
                    if (y < vyska - 1)
                        pristiZbytky[y + 1] += s / 4;

                    //c = Color.FromArgb(s,s,s);

                    bmp.SetPixel(x, y, c);
                }
                Refresh();
            }
        }
        private void button1_Click____(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap)pictureBox2.Image;
            int sirka = pictureBox2.Width;
            int vyska = pictureBox2.Height;

            int hloubka = 3;

            for (int x = 0; x < sirka; x++)
            {
                for (int y = 0; y < vyska; y++)
                {
                    Color c = vzor.GetPixel(x, y);
                    int r = c.R;
                    int g = c.G;
                    int b = c.B;
                    int s = (int)(r * 0.2989 + g * 0.5866 + b * (1 - 0.2989 - 0.5866));

                    int s2 = s;
                    if ((x >= hloubka) && (y >= hloubka))
                    {
                        c = vzor.GetPixel(x - hloubka, y - hloubka);
                        r = c.R;
                        g = c.G;
                        b = c.B;
                        s2 = (int)(r * 0.2989 + g * 0.5866 + b * (1 - 0.2989 - 0.5866));
                    }

                    s = 128 + (s2 - s) / 2;
                    
                    c = Color.FromArgb(s,s,s);
                    bmp.SetPixel(x, y, c);
                }
                Refresh();
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            Font pismo = new System.Drawing.Font("Arial", 144);

            g.DrawString("ABCD", pismo, Brushes.Blue, 100, 100);

            Refresh();
        }
    }
}
